/*
  THIS SOURCE CODE IS SUPPLIED ``AS IS'' WITHOUT WARRANTY OF ANY KIND,
  AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH
  (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL
  WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
  WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND
  RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR
  NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR
  DAMAGES OF ANY KIND RESULTING FROM ITS USE. Withot limiting the
  generality of the foregoing, neither the author, nor JAIR, nor JAIR's
  publishers and distributors, warrant that the Source Code will be
  error-free, will operate without interruption, or will meet the needs
  of the user.
*/

/* Composition table */
char	comptab[MAXREL][MAXREL] = 
        { 
	  {RALL,RC1 ,RC1 ,RDR ,RDR },
	  {RC2 ,RALL,RC5 ,RC2 ,RPO },
	  {RDR ,RC1 ,RPP ,RALL,RPP },
	  {RC2 ,RC6 ,RC7 ,RPQ ,RPQ },
	  {RDR ,RPO ,RPP ,RPQ ,REQ }
        };

/* Inverse table */
char	invtab[MAXREL] = 
	  {RDR ,RPO ,RPQ ,RPP ,REQ};

char comp(char r1,char r2)
{
  int  i,j;
  char result;

  result = 0;

  for (i=0;i<MAXREL;i++) 
    for (j=0;j<MAXREL;j++) 
        if ((r1&(1<<i)) && (r2&(1<<j)))
	  result |= comptab[i][j];
  return(result);
}

char inv(char r1)
{
  int  i;
  char result;

  result = 0;

  for (i=0;i<MAXREL;i++) 
        if (r1&(1<<i)) 
	  result |= invtab[i];
  return(result);
}


