/*
  THIS SOURCE CODE IS SUPPLIED ``AS IS'' WITHOUT WARRANTY OF ANY KIND,
  AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH
  (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL
  WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
  WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND
  RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR
  NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR
  DAMAGES OF ANY KIND RESULTING FROM ITS USE. Withot limiting the
  generality of the foregoing, neither the author, nor JAIR, nor JAIR's
  publishers and distributors, warrant that the Source Code will be
  error-free, will operate without interruption, or will meet the needs
  of the user.
*/

/* This program computes the closure w.r.t. conjunction and
   transitivity for a set of generating relations,
   for the point-interval algebra */

#include <stdlib.h>
#include "rcc5.h"
#include "rcc5basic.c"
#include "rcc5op.c"
#include "rcc5io.c"

void main(int argc, char *argv[])
{
  char geninname[100];
  char algoutname[100];

  int algsize;

  char algset[MAXSET];

  if (argc != 2) {
    printf("Usage: rcc5close <alg-file>\n");
    exit(-1);
  }

  strcpy(geninname,argv[1]);
  strcpy(algoutname,argv[1]);
  add_ext(algoutname,"alg");

  algsize = read_alg(geninname,algset);
  printf("... generating set with %d elements read.\n",algsize);

  printf("Starting closure ...\n");
  compute_closure(algset,&algsize);

  printf("\nClosure has %d elements\n",algsize);

  print_alg(algoutname,algset);

  if (is_intractable(algset))
    printf("and it is intractable.");
}
