/*
  THIS SOURCE CODE IS SUPPLIED ``AS IS'' WITHOUT WARRANTY OF ANY KIND,
  AND ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH
  (JAIR) AND JAIR'S PUBLISHERS AND DISTRIBUTORS, DISCLAIM ANY AND ALL
  WARRANTIES, INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY
  WARRANTIES OR NON INFRINGEMENT. THE USER ASSUMES ALL LIABILITY AND
  RESPONSIBILITY FOR USE OF THIS SOURCE CODE, AND NEITHER THE AUTHOR
  NOR JAIR, NOR JAIR'S PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR
  DAMAGES OF ANY KIND RESULTING FROM ITS USE. Withot limiting the
  generality of the foregoing, neither the author, nor JAIR, nor JAIR's
  publishers and distributors, warrant that the Source Code will be
  error-free, will operate without interruption, or will meet the needs
  of the user.
*/

/* This file is concerned with reading algebras that are known */
/* to be tractable, and checking inclusion in these.           */

#define N_TRACTABLE 4 /* There are four maximal tractable subalgebras */

char  tract_algs[N_TRACTABLE][MAXSET]; /* Storage of the algebras */

int tmp_alg = 0;

void *get_next_alg()

/* Return a pointer to the next algebra to store in */

{
  return(&tract_algs[tmp_alg++]);
}

void read_tract(char *s)

/* Read the next tractable algebra */

{
  read_alg(s,get_next_alg());
}

void init_tractable()

/* Initialise all the tractable algebras */

{

  read_tract("rcc5eq");
  read_tract("rcc5acycl");
  read_tract("rcc5horn");
  read_tract("rcc5disjoint");

  if (tmp_alg != N_TRACTABLE) {
    printf("Wrong number of algebras read.\n");
    exit(-1);
  }
}

char is_in_tractable(char alg[])

/* Check whether the algebra "alg" is known to be tractable. */

{
  int i;
 
 
  for (i=0;i<N_TRACTABLE;i++)
    if (is_subalg(alg,tract_algs[i]))
      return(1);
 
  return(0);
}
 
